unit LISTS;

interface

uses Classes;


         Function ItemExists(const L:Tlist; const ix:integer):boolean;
         Function ListExists(const L:Tlist):boolean;
         Procedure DestroyList(var L:TList);
         Procedure DestroyListItems(const L:TList);
         Function CreateList(var L:TList):boolean;
         procedure DestroyListAndItems(Var L:TList);


implementation

Function ItemExists(const L:Tlist; const ix:integer):boolean;
{ Does the index point to a valid entry in the specified list? }
begin
  result := false;
  if ListExists(L) then
    if ix >= 0 then
      if ix <= L.Count-1 then
        if L.items[ix] <> nil then
          result := true;
end;

Function ListExists(const L:Tlist):boolean;
{Does the list exist (has it been created?)}
begin
     Result := not (L = nil);
end;

Function CreateList(var L:TList):boolean;
{just a TLIST.CREATE but return false if already exists }
begin
  if listexists(L) then begin
    result := false;
  end else begin
    result := true;
    L := Tlist.create;
  end;
end;


Procedure DestroyList(var L:TList);
{destroy the list
NB This doesn't destroy the items pointed to by the list
either call DESTROYLISTITEMS before calling this or use
DESTROYLISTANDITEMS}
begin
     If Listexists(L) then L.free;
end;

Procedure DestroyListItems(const L:TList);
{destroy the items pointed to by the list and clears the list}
var i : integer;
begin
  If Listexists(L) then begin
    For i := 0 to L.Count - 1 do begin
      if L.Items[i] <> nil then Tobject(L.Items[i]).Free;
    end;
    L.Clear;
  end;
end;

procedure DestroyListAndItems(var L:TList);
{destroy all the items in the list then the list itself}
begin
  DestroyListItems(L);
  DestroyList(L);
end;


end.
